/*
 *   [NWERC'11] Binomial Coefficients
 *   by: Jan Kuipers
 */

#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long x;

long long binomial (long long n, int k) {

	long long res=1;
	
	for (int i=0; i<k; i++) {
		if (res > (1+x/(n-i))*(i+1)) return x+1;
		
		res *= n-i;
		res /= i+1;
	}

	return res;
}

int main () {

  int runs;
  cin >> runs;
	
  while (runs--) {

		cin >> x;

		vector<pair<long long,long long> > res;

		// k=1
		res.push_back(make_pair(x,1));
		if (x!=2) res.push_back(make_pair(x,x-1));

		// k=2
		long long n = (long long)(sqrt(8*x+1)+1)/2;
		if (n>=4 && binomial(n,2) == x) {
			res.push_back(make_pair(n,2));
			if (n!=4) res.push_back(make_pair(n,n-2));
		}

		// k>=3
		for (int n=6; binomial(n,3)<=x; n++) {
			int k=3;
			while (k<n && binomial(n,k)<x) k++;
			
			if (binomial(n,k) == x) {
				res.push_back(make_pair(n,k));
				if (n!=2*k)
					res.push_back(make_pair(n,n-k));
			}
		}

		sort(res.begin(),res.end());
		
		cout << res.size() << endl;

		for (int i=0; i<res.size(); i++) {
			if (i>0) cout << " ";
			cout << "(" << res[i].first << "," << res[i].second << ")";
		}
		cout << endl;
  }
	
  return 0;   
}
