/* NWERC'11 solution for binomial
 * Author: Jaap Eldering
 *
 * This algorithm is suboptimal, but still fast: O(cbrt(M))
 * @EXPECTED_RESULTS@: CORRECT
 */

#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <utility>
#include <set>

using namespace std;

typedef long long LL;
typedef pair<LL,LL> P;

LL n1, k1, bin1;

const LL infty = 999999999999999999LL;

LL bin(LL n, LL k)
{
	while ( k<k1 ) {
		bin1 = bin1*k1/(n1-k1+1);
		k1--;
	}
	while ( n>n1 ) {
		if ( (double)bin1*(n1+1)/(n1-k1+1)>infty ) return infty;
		bin1 = bin1*(n1+1)/(n1-k1+1);
		n1++;
	}
	while ( k>k1 ) {
		if ( (double)bin1*(n1-k1)/(k1+1)>infty ) return infty;
		bin1 = bin1*(n1-k1)/(k1+1);
		k1++;
	}
	return bin1;
}

int main()
{
	int nruns;

	cin >> nruns;
	for(int run=1; run<=nruns; run++) {

		LL m;
		cin >> m;

		n1 = 2;
		k1 = 1;
		bin1 = 2;

		LL n, k = 1;
		set<P> res;
		if ( m==2 ) { res.insert(P(2,1)); goto done; }
		if ( m==3 ) { res.insert(P(3,1)); res.insert(P(3,2)); goto done; }

		res.insert(P(m,1));
		res.insert(P(m,m-1));

		// special case solutions M = bin(n,2) = n*(n-1)/2
		n = (int)( (1 + sqrt(1 + 8*m))/2 );
		if ( n*(n-1)/2 == m ) {
			res.insert(P(n,2));
			res.insert(P(n,n-2));
		}

		for(n=4; n*(n-1)*(n-2)/6<=m; n++) {
			while ( k+1<=n/2 && bin(n,k)<m ) k++;
			while ( k-1>0    && bin(n,k)>m ) k--;
			if ( k>2 && bin(n,k)==m ) {
				res.insert(P(n,k));
				res.insert(P(n,n-k));
			}
		}

	  done:
		cout << res.size() << endl;
		int first = 1;
		for(typeof(res.begin()) i=res.begin(); i!=res.end(); ++i) {
			if ( first ) first = 0; else cout << ' ';
			cout << '(' << i->first << "," << i->second << ')';
		}
		cout << endl;
	}

	return 0;
}
