// @EXPECTED_RESULTS@: CORRECT

#include <stdio.h>
#include <set>
#include <algorithm>

using namespace std;

long long binom(long long n, long long k, long long max) {
	long long bin = 1;
	if (k > n - k) k = n - k;
	for (long long i = 1; i <= k; i++) {
		bin *= n--;
		bin /= i;
		if (bin < 0 || bin > max) return max + 1; // avoid overflow
	}
	return bin;
}

int main(int argc, char **argv) {
	int numCases;
	scanf("%d", &numCases);

	while (numCases --> 0) {
		long long M;
		scanf("%lld", &M);

		set<pair<long long, long long> > ways;
		long long i = 0;
		while (binom(2 * i, i, M) <= M) {
			long long low = 2 * i; // values below found before due to symmetry
			long long high = M;
			long long mid = low;
			while (low <= high) {
				mid = (low + high) / 2;
				long long bin = binom(mid, i, M);
				if (bin == M) {
					break;
				} else if (bin < M) {
					low = mid + 1;
				} else {
					high = mid - 1;
				}
			}
			long long bin = binom(mid, i, M);
			if (bin == M) {
				if (mid != i * 2) {
					ways.insert(make_pair(mid,mid-i));
				}
				ways.insert(make_pair(mid,i));
			}

			i++;
		}
		printf("%d\n", (signed) ways.size());
		__typeof__(ways.begin()) it = ways.begin();
		if (it != ways.end()) {
			printf("(%lld,%lld)", it->first, it->second);
			it++;
		}
		while (it != ways.end()) {
			printf(" (%lld,%lld)", it->first, it->second);
			it++;
		}
		puts("");
	}

	return 0;
}
