/*
 *   [NWERC'11] Move to Front
 *   by: Jan Kuipers
 */

#include <iostream>
#include <vector>

using namespace std;

vector<vector<int> > tab;

void init_table (int n) {
	tab.clear();
	for (int dep=0; (1<<dep)<n; dep++) 
		tab.push_back(vector<int>(1<<(dep+1),0));
}

void add_table (int n, int dt) {
	for (int dep=tab.size()-1; dep>=0; dep--) {
		tab[dep][n]+=dt;
		n/=2;
	}
}

int cnt_table (int n) {
	int cnt=0;
	for (int dep=tab.size()-1; dep>=0; dep--) {
		if (n%2==1)	cnt += tab[dep][--n];
		n/=2;		
	}
	return cnt;
}

int main () {

  int runs;
  cin>>runs;

  while (runs--) {

		int N,M;
		cin >> N >> M;

		init_table(N+M);

		vector<int> pos(N);
		for (int i=0; i<N; i++) 
			add_table(pos[i]=M+i, 1);
		
		for (int i=0; i<M; i++) {
			int m;
			cin >> m;
			m--;
			if (i>0) cout << " ";
			cout << cnt_table(pos[m]);
			add_table(pos[m], -1);
			add_table(pos[m]=M-1-i, 1);
		}

		cout << endl;
  }
	
  return 0;   
}
