#include <iostream>
#include <vector>
#include <stack>
#include <cstdio>
using namespace std;

#define rep(i,a,b) for(__typeof(b) i=a; i<(b); ++i)
#define trav(it,c) for(__typeof((c).begin()) it=(c).begin(); it!=(c).end(); ++it)

typedef vector<int> vi;
struct FenwickTree {
    int n;
    vector<int> s;
    FenwickTree(int _n) : n(_n) {
        s.assign(n, 0);
    }
    void update(int pos, int dif) {
        for (; pos < n; pos |= pos + 1)
            s[pos] += dif;
    }
    int query(int val) {
        int count = -1;
        for (; val >= 0; val = (val & (val + 1)) - 1)
            count += s[val];
        return count;
    }
};
int main()
{
    int tests; scanf("%d", &tests);
    rep(test,0,tests)
    {
        int l, n; scanf("%d %d", &l, &n);
        vi when(l);
        FenwickTree t(n + l);
        rep(i,0,l)
        {
            when[i] = n + i;
            t.update(when[i], 1);
        }

        rep(i,0,n)
        {
            int b; scanf("%d", &b);
            b--;
            if (i)
                printf(" ");
            printf("%d", t.query(when[b]));
            t.update(when[b], -1);
            when[b] = n - i - 1;
            t.update(when[b], 1);
        }
        printf("\n");
    }
}
