// Move to Front
// Solution in O(m sqrt n) by Thomas Beuman

#include <cstdio>
#include <list>
#include <cmath>
using namespace std;

int Location[100001]; // Relative location of movie (larger value = lower in stack = farther in list)
list<int> MovieStack;
list<int>::iterator it[320];

int main()
{ int runs, run, n, m, N, interval, r, i, j, request, loc;
  list<int>::iterator z;
  scanf("%d\n", &runs);
  for (run = 0; run < runs; run++)
  { scanf("%d %d\n", &n, &m);
    interval = (int)sqrt(n); // Spacing between iterators
    N = 0;
    // Initialize list
    MovieStack.clear();
    for (i = 1; i <= n; i++)
    { Location[i] = i;
      MovieStack.push_back(i);
      if ((i-1) % interval == 0) // Add iterator to MovieStack-element N*interval
      { it[N] = MovieStack.end();
        it[N++]--;
      }
    }
    for (r = 0; r < m; r++)
    { scanf("%d", &request);
      loc = Location[request];
      for (i = N-1; Location[*it[i]] > loc; i--); // Look for last iterator above the requested movie
      for (j = i*interval, z = it[i]; *z != request; j++, z++); // Look down for requested movie
      printf("%d", j);
      if (r < m-1)
        printf(" ");
      MovieStack.push_front(request); // Put on top of list
      for (; i >= 0; i--)
        it[i]--; // Adjust iterators above 
      MovieStack.erase(z); // Remove from list
      Location[request] = -r;
    }
    printf("\n");
  }
  return 0;
}
