// @EXPECTED_RESULTS@: CORRECT

#include <stdio.h>

#define MAXN (100005*2)
#define FOR(i,a,b) for (int i = (a); i < (b); i++)

int BIT[MAXN + 1];
int pos[MAXN];
int maxIdx;

void add(int idx, int diff) {
	while (idx <= maxIdx) {
		BIT[idx] += diff;
		idx += idx & (-idx);
	}
}

int cumulative(int idx) {
	int ret = 0;

	while (idx != 0) {
		ret += BIT[idx];
		idx -= idx & (-idx);
	}

	return ret;
}

int main(int argc, char **argv) {
	int numCases;
	scanf("%d", &numCases);

	while (numCases --> 0) {
		int numMovies, numRequests;
		scanf("%d%d", &numMovies, &numRequests);

		maxIdx = numMovies + numRequests + 1;
		FOR(i, 0, maxIdx + 1) BIT[i] = 0;
		FOR(i, 1, numMovies + 1) {
			add(i, 1);
			pos[numMovies - i + 1] = i;
		}

		FOR(i, 0, numRequests) {
			int movie;
			scanf("%d", &movie);

			if (i > 0) putchar(' ');
			printf("%d", numMovies - cumulative(pos[movie]));
			add(pos[movie], -1);
			pos[movie] = i + numMovies + 1;
			add(pos[movie], 1);
		}
		puts("");
	}

	return 0;
}
