#include <iostream>
#include <vector>
#include <stack>
#include <cstdio>
#include <algorithm>
using namespace std;

#define rep(i,a,b) for(__typeof(b) i=a; i<(b); ++i)
#define trav(it,c) for(__typeof((c).begin()) it=(c).begin(); it!=(c).end(); ++it)

typedef vector<int> vi;
vi val, num, comp;
int no_vertices, no_components;
stack<int> z;
void dfs(int j, vector<vi> &g) {
    num[j] = val[j] = no_vertices++;
    comp[j] = 0; z.push(j);
    trav(it,g[j])
        if (comp[*it] == -1) {
            dfs(*it, g);
            num[j] = min(num[j], num[*it]);
        }
        else if (comp[*it] == 0)
            num[j] = min(num[j], val[*it]);

    if (val[j] == num[j]) {
        no_components++;
        while (true) {
            comp[z.top()] = no_components;
            if (z.top() == j) { z.pop(); break; }
            z.pop();
        }
    }
}
vector<int> strong_conn(vector<vi> &g) {
    int n = g.size();
    val.assign(n, 0); num = val;
    no_vertices = no_components = 0;
    comp.assign(n, -1);
    for (int i = 0; i < n; i++)
        if (comp[i] == -1) dfs(i, g);
    for (int i = 0; i < n; i++) comp[i]--;
    return comp;
}
char c[1000][1001];
struct union_find {
    vector<int> e;

    union_find(int n) {
        e.assign(n, -1);
    }

    bool same_set(int a, int b){ return (find(a)==find(b));}

    void join(int a, int b) {
        a = find(a); b = find(b);
        if (a == b) return;
        if (e[a] > e[b]) swap(a, b);
        e[a] += e[b]; e[b] = a;
    }

    int find(int x) {
        if (e[x] < 0) return x;
        return e[x] = find(e[x]);
    }
};
int main()
{
    int tests; scanf("%d", &tests);
    rep(test,0,tests)
    {
        int n, m; scanf("%d %d", &n, &m);
        rep(i,0,n)
            scanf("%s", c[i]);

        vector<vi> num(n, vi(m, -1));
        int no = 0;
        rep(i,0,n) rep(j,0,m)
            if (c[i][j] == 'B')
                num[i][j] = no++;
        int dx[] = {0, 1, 0, -1};
        int dy[] = {1, 0, -1, 0};


        union_find w(n * m);
        rep(i,0,n) rep(j,0,m)
            if (c[i][j] != '.')
            rep(k,0,4)
            {
                int s = i + dx[k], t = j + dy[k];
                if (s < 0 || s >= n || t < 0 || t >= m || c[s][t] == '.')
                    continue;
                w.join(i * m + j, s * m + t);
            }
        vi cnt(n * m, 0);
        rep(i,0,n) rep(j,0,m)
            if (c[i][j] == 'W')
                cnt[w.find(i * m + j)]++;
            else if (c[i][j] == 'B')
                cnt[w.find(i * m + j)] -= 2;

        bool ok = count(cnt.begin(), cnt.end(), 0) == n * m;
        if (ok)
        {
            vector<vi> g(4 * no);
            vector<bool> seen(4 * no, false);
            rep(i,0,n) rep(j,0,m)
                if (c[i][j] == 'W')
            {
                vi confl;
                rep(k,0,4)
                {
                    int s = i + dx[k], t = j + dy[k];
                    if (s < 0 || s >= n || t < 0 || t >= m || c[s][t] != 'B')
                        continue;
                    confl.push_back(num[s][t] * 4 + k);
                    seen[num[s][t] * 4 + k] = true;
                }

                rep(k,0,confl.size())
                    rep(l,0,k)
                {
                    g[confl[k]].push_back(confl[l] ^ 2);
                    g[confl[l]].push_back(confl[k] ^ 2);
                }
            }

            rep(i,0,seen.size())
                if (!seen[i])
                    g[i].push_back(i ^ 2);

            vi comp = strong_conn(g);
            rep(i,0,no) rep(j,0,2)
            if (comp[i * 4 + j] == comp[i * 4 + j + 2])
                ok = false;
        }
        cout << (ok ? "YES" : "NO") << endl;
    }
}
