// Piece it Together
// Greedy solution by Thomas Beuman

#include <cstdio>
#include <cstring>
using namespace std;

int n, m;
char Pattern[502][502];
bool Matched[501][501][2];
int di[4] = {0, -1, 0, 1}, dj[4] = {-1, 0, 1, 0};

bool possible()
{ int b, w, i, j, d, d0, i1, j1, i2, j2;
  // Count number of black and white squares
  b = w = 0;
  for (i = 1; i <= n; i++)
    for (j = 1; j <= m; j++)
      switch (Pattern[i][j])
      { case 'B' : b++; break;
        case 'W' : w++; break;
      }
  if (w != 2*b)
    return false;
  memset(Matched, false, sizeof(Matched));
  for (i = 1; i <= n; i++)
    for (j = 1; j <= m; j++)
    { i1 = i;
      j1 = j;
      while (Pattern[i1][j1] == 'W' && !Matched[i1][j1][0])
      { // Look for adjacent unmatched black squares
        d0 = -1;
        for (d = 0; d < 4; d++)
        { i2 = i1 + di[d];
          j2 = j1 + dj[d];
          if (Pattern[i2][j2] == 'B' && !Matched[i2][j2][d&1])
          { if (d0 < 0) // First match found
              d0 = d;
            else
              break;
          }
        }
        if (d0 < 0) // No possibilities
          return false;
        if (d < 4) // Multiple possibilities
          break;
        i2 = i1 + di[d0];
        j2 = j1 + dj[d0];
        Matched[i1][j1][0] = Matched[i2][j2][d0&1] = true;
        i1 = i2 + di[d0], j1 = j2 + dj[d0];
        // The square on the opposite side (if white) has lost a possibility; check it
      }
    }
  return true;
}

int main()
{ int runs, run, i;
  scanf("%d\n", &runs);
  for (run = 0; run < runs; run++)
  { scanf("%d %d\n", &n, &m);
    // Read in pattern and put dots around the perimeter
    for (i = 1; i <= n; i++)
    { scanf("%s\n", Pattern[i]+1);
      Pattern[i][0] = Pattern[i][m+1] = '.';
    }
    memset(Pattern[0], '.', m+2);
    memset(Pattern[n+1], '.', m+2);
    printf("%s\n", possible() ? "YES" : "NO");
  }
  return 0;
}

