/*
 *  [NWERC'11] Pool Construction
 *  by: Jan Kuipers
 */

#include <iostream>
#include <vector>
#include <string>
#include <climits>

using namespace std;

const int dy[4] = {-1,0,0,1};
const int dx[4] = {0,-1,1,0};

int X,Y,D,F,B;
vector<string> map;
vector<vector<bool> > used;
vector<vector<int> > sourflow, sinkflow;
vector<vector<vector<int> > > flow;

int max_flow (int y, int x, int push) {

  if (push==0 || used[y][x]) return 0;
  used[y][x] = true;

  if (map[y][x]=='.' && sinkflow[y][x]<F) {
    push = min(push,F-sinkflow[y][x]);
    sinkflow[y][x] += push;
    return push;
  }

  for (int d=0; d<4; d++) {
    int ny = y+dy[d];
    int nx = x+dx[d];
    if (ny<0 || ny>=Y || nx<0 || nx>=X) continue;

    int npush = max_flow(ny,nx,min(push,B-flow[y][x][d]));
    if (npush > 0) {
      flow[y][x][d] += npush;
      flow[ny][nx][3-d] -= npush;
      return npush;
    }
  }
	
  return 0;
}

int main () {

  int runs;
  cin >> runs;

  while (runs--) {

    cin >> X >> Y >> D >> F >> B;

    map = vector<string>(Y);
    for (int y=0; y<Y; y++)
      cin >> map[y];

    sourflow = sinkflow = vector<vector<int> >(Y, vector<int>(X, 0));
    flow = vector<vector<vector<int> > >(Y, vector<vector<int> >(X, vector<int>(4, 0)));

    int res=0;
    
    for (int y=0; y<Y; y++) 
      for (int x=0; x<X; x++) {
	bool boundary = y==0 || y==Y-1 || x==0 || x==X-1;
	if (boundary && map[y][x]=='.') {
	  res += F;
	  map[y][x] = '#';
	}
      }

    for (int y=0; y<Y; y++) 
      for (int x=0; x<X; x++)
	if (map[y][x] == '#' ) {
	  bool boundary = y==0 || y==Y-1 || x==0 || x==X-1;

	  int push;
	  do {
	    used = vector<vector<bool> >(Y, vector<bool>(X, false));
	    push = max_flow(y, x, boundary ? INT_MAX : D - sourflow[y][x]);
	    sourflow[y][x] += push;
	    res += push;
	  }
	  while (push>0);
	}
	
    cout << res << endl;
  }
  
  return 0;
}
