#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <math.h>

#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define MAXM 100
#define MAXNAME 1000

char names[MAXM][MAXNAME];
int X[MAXM];
int Y[MAXM];
bool shot[MAXM];
bool printed[MAXM];
bool done[MAXM][MAXM];
double mintime[MAXM][MAXM];
bool first;
int M;

int getname(char name[MAXNAME]) {
	int i = 0;
	while(strcmp(name, names[i])) i++;
	return i;
}

double dist(int p1, int p2) {
	double dx, dy;
	dx = X[p1] - X[p2];
	dy = Y[p1] - Y[p2];
	return sqrt(dx * dx + dy * dy);
}

void recprint(int i) {
	int j;
	if(printed[i] || !shot[i]) return;
	printed[i] = true;
	for(j = 0; j < M; j++) {
		if(!shot[j] || j == i) continue;
		if((done[i][j] && mintime[i][j] < 0) || (done[j][i] && mintime[j][i] > 0))
			recprint(j);
	}
	if(!first) printf(" ");
	else first = false;
	printf("%s", names[i]);
}

void testcase() {
	int i, j, k, N, n1, n2, n3;
	char name1[MAXNAME], name2[MAXNAME], name3[MAXNAME];
	double d2, d3;
	memset(shot, false, sizeof(shot));
	memset(done, false, sizeof(done));
	scanf("%d %d\n", &M, &N);
	for(i = 0; i < M; i++)
		scanf("%s %d %d\n", names[i], &X[i], &Y[i]);
	for(i = 0; i < N; i++) {
		scanf("%s heard %s firing before %s\n", name1, name2, name3);
		n1 = getname(name1);
		n2 = getname(name2);
		n3 = getname(name3);
		d2 = dist(n1, n2);
		d3 = dist(n1, n3);
		shot[n2] = shot[n3] = true;
		if(done[n2][n3]) {
			mintime[n2][n3] = MAX(mintime[n2][n3], d2 - d3);
		} else {
			done[n2][n3] = true;
			mintime[n2][n3] = d2 - d3;
		}
	}
	for(i = 0; i < M; i++) {
		if(!shot[i]) continue;
		for(j = 0; j < M; j++) {
			if(!shot[j] || !done[j][i]) continue;
			for(k = 0; k < M; k++) {
				if(!shot[k] || !done[i][k]) continue;
				if(!done[j][k]) {
					mintime[j][k] = mintime[j][i] + mintime[i][k];
					done[j][k] = true;
				} else {
					mintime[j][k] = MAX(mintime[j][k], mintime[j][i] + mintime[i][k]);
				}
			}
		}
	}
	// Check for Impossible
	for(i = 0; i < M; i++) {
		if(!shot[i]) continue;
		if(done[i][i] && mintime[i][i] > 0) {
			printf("IMPOSSIBLE\n");	
			return;
		}
		for(j = 0; j < M; j++) {
			if(!shot[j] || i == j) continue;
			//fprintf(stderr, "%s -> %s: %lf\n",names[i],names[j],mintime[i][j]);
			if(done[i][j] && done[j][i] && mintime[i][j] >= 0 && mintime[j][i] >= 0 && mintime[i][j] + mintime[j][i] > 0) {
				printf("IMPOSSIBLE\n");
				return;
			}
		}
	}
	// Check for Unknown
	for(i = 0; i < M; i++) {
		if(!shot[i]) continue;
		for(j = 0; j < M; j++) {
			if(!shot[j] || i == j) continue;
			if((!done[i][j] || mintime[i][j] <= 0) && (!done[j][i] || mintime[j][i] <= 0)) {
				printf("UNKNOWN\n");
				return;
			}
		}
	}

	// Print answer
	memset(printed, false, sizeof(printed));
	first = true;
	for(i = 0; i < M; i++)
		recprint(i);
	printf("\n");
}

int main() {
	int t;
	scanf("%d\n",&t);
	while(t--) testcase();
	return 0;
}
