/*
 *   [NWERC'11] Tichu
 *   by: Jan Kuipers
 */

#include <vector>
#include <string>
#include <iostream>

using namespace std;

int main () {

	int runs;
	cin >> runs;

	while (runs--) {

		vector<string> card(13);
		vector<int> rank(13);
		for (int i=0; i<13; i++) {
			cin >> card[i];
			rank[i] = string("23456789TJQKA").find(card[i][0]);
		}

		vector<int> valid;
		for (int i=1; i<1<<13; i++) {
			vector<int> num_rank(13,0);
			for (int j=0; j<13; j++)
				if (i & (1<<j)) num_rank[rank[j]]++;

			int hi_rank=0,lo_rank=13;
			vector<int> n(5,0);
			for (int j=0; j<13; j++)
				if (num_rank[j]>0) {
					hi_rank = max(hi_rank,j);
					lo_rank = min(lo_rank,j);
					n[num_rank[j]]++;
				}

			int L = hi_rank-lo_rank+1;
			if (n[1]==1 && n[2]==0 && n[3]==0 && n[4]==0) valid.push_back(i); // single
			if (n[1]==0 && n[2]==1 && n[3]==0 && n[4]==0) valid.push_back(i); // pair
			if (n[1]==0 && n[2]==0 && n[3]==1 && n[4]==0) valid.push_back(i); // trips
			if (n[1]==0 && n[2]==0 && n[3]==0 && n[4]==1) valid.push_back(i); // quads
			if (n[1]==0 && n[2]==1 && n[3]==1 && n[4]==0) valid.push_back(i); // full house
			if (n[2]==0 && n[3]==0 && n[4]==0 && n[1]==L && L>=5) valid.push_back(i); // straight
		}

		vector<int> best(1<<13,14);
		vector<int> use(1<<13);
		best[0]=0;
		for (int i=1; i<1<<13; i++)
			for (int j=0; j<valid.size(); j++)
				if ((i & valid[j]) == valid[j] && best[i] > best[i & ~valid[j]]+1) {
					best[i] = best[i & ~valid[j]]+1;
					use[i] = valid[j];
				}

		int left = (1<<13)-1;
		cout << best[left] << endl;
		
		while (left) {
			bool first=true;
			for (int i=0; i<13; i++)
				if (use[left] & (1<<i)) {
					if (!first) cout<<" ";
					first=false; 
					cout << card[i];
				}
			cout << endl;
			
			left &= ~use[left];
		}
	}
	
	return 0;
}
