/*
 *   [NWERC'11] Tichu
 *   by: Jan Kuipers
 */

#include <vector>
#include <string>
#include <iostream>

using namespace std;

vector<int> cnt;
vector<vector<int> > sol,best,which;

void add (int a) {
	for (int i=0; i<a; i++)
		sol.back().push_back(which[a].back());
	which[a].pop_back();
}

void pick_sets () {

	int sol_sz=sol.size();
	
	which = vector<vector<int> >(5);
	for (int i=0; i<13; i++)
		which[cnt[i]].push_back(i);

	// trips + pair = full house
	while (which[3].size()>=1 && which[2].size()>=1) {
		sol.push_back(vector<int>());
		add(3);
		add(2);
	}

	// 2x trips + quads = 2x full house
	while  (which[3].size()>=2 && which[4].size()>=1) {
		which[2].push_back(which[4].back());
		which[2].push_back(which[4].back());
		which[4].pop_back();
		sol.push_back(vector<int>());
		add(3);
		add(2);
		sol.push_back(vector<int>());
		add(3);
		add(2);
	}

	// quads, trips, pairs en singletons
	for (int i=1; i<=4; i++)
		while (which[i].size()>=1) {
			sol.push_back(vector<int>());
			add(i);
		}

	if (sol.size()<best.size()) best=sol;
	sol.resize(sol_sz);
}

void pick_straight () {

	pick_sets();
	
	bool ok;

	for (int fr=0; fr<13; fr++)
		for (int to=fr+5; to<=13; to++) {
			ok=true;
			for (int i=fr; i<to; i++)
				if (cnt[i]==0) ok=false;
			if (!ok) continue;
							
			sol.push_back(vector<int>());
			for (int i=fr; i<to; i++) {
				sol.back().push_back(i);
				cnt[i]--;
			}
			
			pick_straight();

			sol.pop_back();
			for (int i=fr; i<to; i++)
				cnt[i]++;
		}
}
	
int main () {

	int runs;
	cin >> runs;

	while (runs--) {

		vector<string> card(13);
		vector<int> rank(13);
		cnt = vector<int>(13,0);
		
		for (int i=0; i<13; i++) {
			cin >> card[i];
			rank[i] = string("23456789TJQKA").find(card[i][0]);
			cnt[rank[i]]++;
		}

		best=vector<vector<int> >(99);
		pick_straight();

		vector<bool> used(13,false);
		
		cout << best.size() << endl;
		for (int i=0; i<best.size(); i++) {
			for (int j=0; j<best[i].size(); j++)
				for (int k=0; k<13; k++)
					if (!used[k] && rank[k]==best[i][j]) {
						if (j>0) cout << " ";
						cout << card[k];
						used[k] = true;
						break;
					}
			cout << endl;
		}			
	}
	
	return 0;
}
