// @EXPECTED_RESULTS@: CORRECT
import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.geom.*;

class PointCompare implements Comparator<Point> {
	public int compare(final Point a, final Point b) {
		if (a.x != b.x) return a.x - b.x;
		return a.y - b.y;
	}
}

public class tobi {
	public static final int MAX_WALLS = 10;
	public static final int MAX_COORD = (10000+2);
	public static final HashMap<Integer, ArrayList<Point>> circles = new HashMap<Integer, ArrayList<Point>>();
	public static final ArrayList<Line2D.Double> walls = new ArrayList<Line2D.Double>();

	public static int HASH(Point p, int xAdd, int yAdd, int radius) {
		int xquadr = (xAdd + p.x + MAX_COORD) / radius;
		int yquadr = (yAdd + p.y + MAX_COORD) / radius;
		return xquadr * MAX_COORD + yquadr;
	}

	public static void main(String args[]) throws Exception {
		Scanner sc = new Scanner(System.in);
		int numCases = sc.nextInt();

		while (numCases --> 0) {
			circles.clear();
			walls.clear();
			int numCircles = sc.nextInt();
			int radius = sc.nextInt();
			int numWalls = sc.nextInt();
			int numQueries = sc.nextInt();

			for (int i = 0; i < numCircles; i++) {
				int x = sc.nextInt();
				int y = sc.nextInt();
				Point p = new Point(x, y);
				if (circles.get(HASH(p, 0, 0, radius)) == null) {
					circles.put(HASH(p, 0, 0, radius), new ArrayList<Point>());
				}
				ArrayList<Point> pList = circles.get(HASH(p, 0, 0, radius));
				pList.add(p);
			}
			for (int i = 0; i < numWalls; i++) {
				double x1 = sc.nextInt();
				double y1 = sc.nextInt();
				double x2 = sc.nextInt();
				double y2 = sc.nextInt();
				Line2D.Double l = new Line2D.Double(x1,y1,x2,y2);
				walls.add(l);
			}

			for (int i = 0; i < numQueries; i++) {
				Point p = new Point();
				p.x = sc.nextInt();
				p.y = sc.nextInt();

				SortedSet<Point> result = new TreeSet<Point>(new PointCompare());
				for (int x = -radius; x <= radius; x += radius) {
					for (int y = -radius; y <= radius; y += radius) {
						ArrayList<Point> pList = circles.get(HASH(p, x, y, radius));
						if (pList != null) {
							for (Point sensor : pList) {
								if (p.distance(sensor) <= (double) radius) {
									Line2D.Double l = new Line2D.Double(p, sensor);
									int intersect = 0;
									for (Line2D.Double wall : walls) {
										if (wall.intersectsLine(l)) {
											intersect++;
										}

									}
								
									if (p.distance(sensor) <= (double) (radius - intersect)) {
										result.add(sensor);
									}
								}
							}
						}
					}
				}

				System.out.print(result.size());
				for (Point sensor : result) {
					System.out.print(" (" + sensor.x + "," + sensor.y + ")");
				}
				System.out.println("");
			}

		}
	}
}
