#include <stdio.h>
#include <string.h>

#define NMAX 111

int ndays[13] = {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
char d[NMAX], mmdd[NMAX], yyyy[NMAX];
int N, L, i, day, month, max_year_prefix, year, yy, md, yp, dd, mm, dsol, msol, ysol, dmax, yearprefix, yearpow, yearsuffix, solfound, suffix;
int test_suffix[10], test_pow[10], ntest_suffixes, is_pali;

char digits[NMAX];

int IsPalindrome(int number, int ypow) {
	int ndigits = 0, i;

	while (ypow > 1) {
		ndigits++;
		digits[ndigits] = number % 10;
		number /= 10;
		ypow /= 10;
	}

	for (i = ndigits / 2 + 1; i <= ndigits; i++)
		if (digits[i] != digits[ndigits - i + 1])
			return 0;

	return 1;
}

void GetNextPalindrome(int number, int ypow) {
	int ndigits = 0, i;

	while (ypow > 1) {
		ndigits++;
		digits[ndigits] = number % 10;
		number /= 10;
		ypow /= 10;
	}

	int can_inc = 0;

	for (i = ndigits / 2; i >= 1; i--)
		if (digits[i] > digits[ndigits - i + 1])
			break;
		else if (digits[i] < digits[ndigits - i + 1]) {
			can_inc = 1;
			break;
		}
	
	if (!can_inc) {
		for (i = ndigits / 2 + 1; i <= ndigits; i++)
			if (digits[i] < 9) {
				break;
			}
		
		if (i > ndigits)
			return;
		digits[i]++;

		for (i--; i >= ndigits / 2 + 1; i--)
			digits[i] = 0;
	}

	for (i = ndigits / 2 + 1; i <= ndigits; i++)
		digits[ndigits - i + 1] = digits[i];
	
	number = 0;
	for (i = ndigits; i >= 1; i--)
		number = number * 10 + digits[i];
	//fprintf(stderr, "%d\n", number);
	test_suffix[ntest_suffixes] = number;
	test_pow[ntest_suffixes] = yearpow;
	ntest_suffixes++;
}

int main() {
	int cnt = 0;
	while (scanf("%s", d + 1) == 1) {
		N = strlen(d + 1);
		day = month = year = 0;
		for (i = 1; i <= N; i++) {
			if (d[i] == '/')
				break;
			day = day * 10 + (d[i] - '0');
		}
		i++;
		for (; i <= N; i++) {
			if (d[i] == '/')
				break;
			month = month * 10 + (d[i] - '0');
		}
		i++;
		for (; i <= N; i++) {
			if (d[i] == '/')
				break;
			year = year * 10 + (d[i] - '0');
		}
		
		//fprintf(stderr, "day=%d month=%d year=%d\n", day, month, year);

		if (year >= 10000) {
			// Adjust the year.
			yearprefix = year;
			yearpow = 1;
			yearsuffix = 0;
			while (yearprefix >= 10000) {
				yearsuffix += (yearprefix % 10) * yearpow;
				yearpow *= 10;
				yearprefix /= 10;
			}

			ntest_suffixes = 4;
			test_suffix[0] = 0;
			test_pow[0] = yearpow;
			test_suffix[1] = 0;
			test_pow[1] = yearpow * 10;

			test_pow[2] = yearpow;
			test_suffix[2] = 0;
			for (i = 10; i <= yearpow; i *= 10)
				test_suffix[2] = test_suffix[2] * 10 + 4;

			test_pow[3] = yearpow * 10;
			test_suffix[3] = test_suffix[2] * 10 + 4;
			
			if (yearsuffix > 0 && IsPalindrome(yearsuffix, yearpow)) {
				test_suffix[ntest_suffixes] = yearsuffix;
				test_pow[ntest_suffixes] = yearpow;
				ntest_suffixes++;
			}

			// Make the year suffix a palindrome.
			GetNextPalindrome(yearsuffix, yearpow);
			
			max_year_prefix = yearprefix + 1;
		} else {
			yearprefix = year;
			yearpow = 1;

			ntest_suffixes = 5;
			test_pow[0] = 1;
			test_pow[1] = 2;
			test_pow[2] = 3;
			test_pow[3] = 4;
			test_pow[4] = 5;
			
			//if (year < 1000)
			//	max_year_prefix = 1000;
			//else
				max_year_prefix = yearprefix + 1;
		}
		
		solfound = 0;
		ysol = msol = dsol = -1;
		for (mm = 1; mm <= 12; mm++) {
			for (dd = 1; dd <= ndays[mm]; dd++) {
				for (suffix = 0; suffix < ntest_suffixes; suffix++) {
					yp = ((dd % 10) * 10 + (dd / 10)) * 100 + (mm % 10) * 10 + (mm / 10);
					if (yp < 1000)
						continue;
						
					if (year >= 10000) {
						if ((2147483647 - test_suffix[suffix]) / test_pow[suffix] < yp)
							continue;
						yy = yp * test_pow[suffix] + test_suffix[suffix];
						is_pali = 1;

						//fprintf(stderr, "%d %02d%02d -- %d\n", yp, mm, dd, yy);
					} else {
						md = mm * 100 + dd;
						
						//fprintf(stderr, "%d %d %d\n", yp, md, test_pow[suffix]);
						
						is_pali = 0;
						if (test_pow[suffix] == 1) {
							if (yp % 1000 == md / 10) {
								is_pali = 1;
								yy = yp / 1000;
							}
						} else if (test_pow[suffix] == 2) {
							if (yp % 100 == md / 100) {
								is_pali = 1;
								yy = yp / 100;
							}
						} else if (test_pow[suffix] == 3) {
							if (yp % 10 == md / 1000) {
								is_pali = 1;
								yy = yp / 10;
							}
						} else {
							is_pali = 1;
							yy = yp;
							if (test_pow[suffix] == 5)
								yy *= 10;
						}

						/*
						sprintf(mmdd, "%02d%02d", mm, dd);
						sprintf(yyyy, "%d", yp);
						is_pali = 1;
						for (i = test_pow[suffix]; i < 4; i++)
							if (yyyy[i] != mmdd[i - test_pow[suffix]]) {
								is_pali = 0;
								break;
							}
						
						if (is_pali) {
							yy = 0;
							for (i = 0; i < test_pow[suffix] && i < 4; i++)
								yy = yy * 10 + (yyyy[i] - '0');
							if (test_pow[suffix] == 5)
								yy *= 10;
						}
						*/
					}

					if (is_pali) {
						if (yy > year || (yy == year && mm > month) ||
							((yy == year) && (mm == month) && (dd > day))) {
							if (mm == 2 && dd == 29 && !(yy % 400 == 0) && !(yy % 4 == 0 && yy % 100 > 0))
								continue;
							if (!solfound || yy < ysol || (yy == ysol && mm < msol) ||
								(yy == ysol && mm == msol && dd < dsol)) {
								solfound = 1;
								dsol = dd;
								msol = mm;
								ysol = yy;
							}
						}
					}
				}
			}
		}
	
		printf("%02d/%02d/%d\n", dsol, msol, ysol);

		cnt++;
		if (cnt % 1000 == 0)
			fprintf(stderr, "cnt=%d day=%d month=%d year=%d %02d/%02d/%d\n", cnt, day, month, year, dsol, msol, ysol);
	}
	
	return 0;
}
