#include <stdio.h>
#include <set>

using namespace std;

#define NMAX 100100

set<pair<int, int> > costs;
set<pair<pair<int, double>, int> > dominating, to_remove;
set<pair<pair<int, double>, int> >::iterator it;
int c[NMAX];
int N, k, answer, px;
double zr;
char action;

int main() {
	int T, first, cnt = 0;
	scanf("%d", &T);

	while (T--) {
		scanf("%d", &N);
		first = 1;
		
		dominating.clear();
		costs.clear();

		for (k = 1; k <= N; k++) {
			scanf(" %c", &action);
			if (action == 'C') {
				if (costs.size() == 0)
					answer = -1;
				else
					answer = costs.begin()->second;
				if (!first)
					printf(" ");
				printf("%d", answer);
				first = 0;
			} else {
				scanf("%d %lf %d", &px, &zr, &c[k]);
				pair<pair<int, double>, int> point;
				pair<int, int> cost;
				point.first.first = px;
				point.first.second = zr;
				point.second = -k;
				cost.first = c[k];
				cost.second = k;
				
				if (dominating.size() == 0) {
					dominating.insert(point);
					costs.insert(cost);
				} else {
					it = dominating.lower_bound(point);
					if (it != dominating.end()) {
						if ((it->first.first > point.first.first &&
							it->first.second >= point.first.second) ||
							(it->first.first >= point.first.first &&
							it->first.second > point.first.second))
							continue;
					}
					
					if (it == dominating.begin()) {
						dominating.insert(point);
						costs.insert(cost);
						continue;
					}
					
					to_remove.clear();
					
					do {
						it--;
						if ((point.first.first > it->first.first &&
							 point.first.second >= it->first.second) ||
							(point.first.first >= it->first.first &&
							 point.first.second > it->first.second)) {
							to_remove.insert(*it);
							//fprintf(stderr, "(%d,%lf) dominates (%d,%lf)\n", point.first.first, point.first.second, it->first.first, it->first.second);
						} else
							break;
					} while (it != dominating.begin());

					for (it = to_remove.begin(); it != to_remove.end(); it++) {
						dominating.erase(*it);
						costs.erase(make_pair(c[-(it->second)], -(it->second)));
					}

					dominating.insert(point);
					costs.insert(cost);
				}
			}
		}
		
		printf("\n");

		cnt++;
		fprintf(stderr, "done %d\n", cnt);
	}
	
	return 0;
}
